;Torpedo enemy, by Tundain.

;This enemy, which is featured in my romhack V E R T I C A L I T Y, is a torpedo which lurks within the walls, and once samus is at around the same height as it is, will get fired and accelerate until it hits a wall
;inlcudes are the gfx, palette and XML file to put in your export->enemies folder

;here are some defines to help you tweak it to your desired behavior
;don't forget to set the right data in the SMART enemy editor (such as bank, Init AI, main AI)
;set the SMART logging mode to debug to view the init/main AI addresses!

!AccelSpeed = #$0000;speed at which it accelerates, in pixels
!SubAccelSpeed = #$1800;speed at which it accelerates in subpixels

!EnemyBankFreespace = $A2F500;find yourself some freespace in any enemy bank

org !EnemyBankFreespace
print "Torpedo Init AI: $",pc
LDX $0E54
LDY $0FB4,x : LDA initinsts,y : STA $0F92,x
LDA #checking : STA $0FA8,x
RTL

initinsts:
DW launchingright,launchingleft

print "Torpedo main ai: $",pc
LDX $0E54
JSR ($0FA8,x)
RTL

checking:;checks if samus is within range before firing
LDA #$0020 : JSL $A0AEED : BEQ +
LDY $0FB4,x
LDA nextones,y : STA $0FA8,x
LDA nextinsts,y : STA $0F92,x
LDA #$0001 : STA $0F94,x
LDA #$001F : JSL $80912F
+
RTS
nextones:
DW firedright,firedleft
nextinsts:
DW launchedright,launchedleft

move:;moves the torpedo according to it's movement speed
LDA $0FAE,x : STA $14 : LDA $0FB0,x : STA $12 : JSL $A0C786
LDA $0FAA,x : STA $14 : LDA $0FAC,x : STA $12 : JSL $A0C6AB
RTS
;accelerating to the left/right
firedright:
JSR move : BCS destroy
LDA $0FAC,x : CLC : ADC !SubAccelSpeed : STA $0FAC,x
LDA $0FAA,x : ADC !AccelSpeed : STA $0FAA,x
RTS
firedleft:
JSR move : BCS destroy
LDA $0FAC,x : SEC : SBC !SubAccelSpeed : STA $0FAC,x
LDA $0FAA,x : SBC !AccelSpeed : STA $0FAA,x
RTS
destroy:;when colliding with wall, spawn super missile explosion sprite on top of regular explosion
LDA #$DAFF : STA $0F78,x
LDY #splosion : JSL $868097
TDC : JSL $A0A3AF
LDA #$0007 : JSL $8090AD
RTS

launchingright:
DW $0001,static
DW $812F
launchedright:
DW $0005,firesmall
DW $0005,firemedium
DW $0005,firelarge
DW $0005,firemedium
DW $80ED,launchedright
launchingleft:
DW $0001,staticleft
DW $812F
launchedleft:
DW $0005,firesmallleft
DW $0005,firemediumleft
DW $0005,firelargeleft
DW $0005,firemediumleft
DW $80ED,launchedleft
;this is the torpedo itself
static:
DW $0002
DW $81F0 : DB $F8 : DW $2103
DW $8000 : DB $F8 : DW $2105

;these three is the fire behind the torpedo
firelarge:
DW $0006
DW $81F0 : DB $F8 : DW $2103
DW $8000 : DB $F8 : DW $2105
DW $01E0 : DB $FC : DW $2100
DW $01E8 : DB $FC : DW $2101
DW $01ED : DB $F7 : DW $2112
DW $01ED : DB $02 : DW $2112
firemedium:
DW $0006
DW $81F0 : DB $F8 : DW $2103
DW $8000 : DB $F8 : DW $2105
DW $01E0 : DB $FC : DW $2110
DW $01E8 : DB $FC : DW $2111
DW $01EF : DB $F7 : DW $2112
DW $01EF : DB $02 : DW $2112
firesmall:
DW $0003
DW $81F0 : DB $F8 : DW $2103
DW $8000 : DB $F8 : DW $2105
DW $01E8 : DB $FC : DW $2112
;idem but when facing left
staticleft:
DW $0002
DW $81F0 : DB $F8 : DW $6105
DW $8000 : DB $F8 : DW $6103

firelargeleft:
DW $0006
DW $81F0 : DB $F8 : DW $6105
DW $8000 : DB $F8 : DW $6103
DW $0018 : DB $FC : DW $6100
DW $0010 : DB $FC : DW $6101
DW $000B : DB $F7 : DW $6112
DW $000B : DB $02 : DW $6112

firemediumleft:
DW $0006
DW $81F0 : DB $F8 : DW $6105
DW $8000 : DB $F8 : DW $6103
DW $0018 : DB $FC : DW $6110
DW $0010 : DB $FC : DW $6111
DW $0009 : DB $F7 : DW $6112
DW $0009 : DB $02 : DW $6112
firesmallleft:
DW $0003
DW $81F0 : DB $F8 : DW $6105
DW $8000 : DB $F8 : DW $6103
DW $0010 : DB $FC : DW $6112
